import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wijmo from '@mescius/wijmo';
import * as input from '@mescius/wijmo.input';
import * as sheet from '@mescius/wijmo.grid.sheet';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let fonts = [
{ name: 'Arial', value: 'Arial, Helvetica, sans-serif' },
{ name: 'Arial Black', value: '"Arial Black", Gadget, sans-serif' },
{ name: 'Comic Sans MS', value: '"Comic Sans MS", cursive, sans-serif' },
{ name: 'Courier New', value: '"Courier New", Courier, monospace' },
{ name: 'Georgia', value: 'Georgia, serif' },
{ name: 'Impact', value: 'Impact, Charcoal, sans-serif' },
{ name: 'Lucida Console', value: '"Lucida Console", Monaco, monospace' },
{ name: 'Lucida Sans Unicode', value: '"Lucida Sans Unicode", "Lucida Grande", sans-serif' },
{ name: 'Palatino Linotype', value: '"Palatino Linotype", "Book Antiqua", Palatino, serif' },
{ name: 'Tahoma', value: 'Tahoma, Geneva, sans-serif' },
{ name: 'Segoe UI', value: '"Segoe UI", "Roboto", sans-serif' },
{ name: 'Times New Roman', value: '"Times New Roman", Times, serif' },
{ name: 'Trebuchet MS', value: '"Trebuchet MS", Helvetica, sans-serif' },
{ name: 'Verdana', value: 'Verdana, Geneva, sans-serif' }
];
//
let fontSizeList = [
{ name: '8', value: '8px' },
{ name: '9', value: '9px' },
{ name: '10', value: '10px' },
{ name: '11', value: '11px' },
{ name: '12', value: '12px' },
{ name: '14', value: '14px' },
{ name: '16', value: '16px' },
{ name: '18', value: '18px' },
{ name: '20', value: '20px' },
{ name: '22', value: '22px' },
{ name: '24', value: '24px' }
];
//
let updatingSelection = false;
let applyFillColor = false;
let selectionFormatState = {};
let flexSheet = new sheet.FlexSheet('#formatSheet');
let inputColor = new input.ColorPicker('#inputColor');
//
let formatMenu = new input.Menu('#formatMenu', {
selectedIndex: 0,
selectedIndexChanged: (sender) => {
if (sender.selectedIndex >= 0) {
updateMenuHeader(sender, 'Format');
if (!updatingSelection) {
flexSheet.applyCellsStyle({ format: sender.selectedValue });
}
}
}
});
updateMenuHeader(formatMenu, 'Format');
//
let cboFontName = new input.ComboBox('#fonts', {
itemsSource: fonts,
displayMemberPath: 'name',
selectedValuePath: 'value',
isEditable: false
});
//
let cboFontSize = new input.ComboBox('#fontSize', {
itemsSource: fontSizeList,
selectedIndex: 5,
displayMemberPath: 'name',
selectedValuePath: 'value',
isEditable: false
});
//
flexSheet.addUnboundSheet('Number', 20, 8);
flexSheet.addUnboundSheet('Date', 20, 8);
flexSheet.deferUpdate(() => {
for (let sheetIdx = flexSheet.sheets.length - 1; sheetIdx >= 0; sheetIdx--) {
flexSheet.selectedSheetIndex = sheetIdx;
let sheetName = flexSheet.selectedSheet.name;
//
for (let colIdx = 0; colIdx < flexSheet.columns.length; colIdx++) {
for (let rowIdx = 0; rowIdx < flexSheet.rows.length; rowIdx++) {
if (sheetName === 'Number') {
flexSheet.setCellData(rowIdx, colIdx, colIdx + rowIdx);
}
else {
let date = new Date(2018, colIdx, rowIdx + 1);
flexSheet.setCellData(rowIdx, colIdx, date);
}
}
}
}
flexSheet.selectedSheetIndex = 0;
setTimeout(() => updateSelection(flexSheet.selection), 100);
});
//
flexSheet.selectionChanged.addHandler((sender, args) => {
updateSelection(args.range);
});
//
// Hide the color picker control when it lost the focus.
let blurEvt = /firefox/i.test(window.navigator.userAgent) ? 'blur' : 'focusout';
inputColor.hostElement.addEventListener(blurEvt, () => {
setTimeout(() => {
if (!inputColor.containsFocus()) {
applyFillColor = false;
inputColor.hostElement.style.display = 'none';
}
}, 0);
});
//
// Initialize the value changed event handler for the color picker control.
inputColor.valueChanged.addHandler(() => {
if (applyFillColor) {
flexSheet.applyCellsStyle({ backgroundColor: inputColor.value });
}
else {
flexSheet.applyCellsStyle({ color: inputColor.value });
}
});
//
cboFontName.selectedIndexChanged.addHandler(() => {
// apply the font family for the selected cells
if (!updatingSelection) {
flexSheet.applyCellsStyle({ fontFamily: cboFontName.selectedItem.value });
}
});
//
cboFontSize.selectedIndexChanged.addHandler(() => {
// apply the font size for the selected cells
if (!updatingSelection) {
flexSheet.applyCellsStyle({ fontSize: cboFontSize.selectedItem.value });
}
});
//
onClick('applyCellTextLeftAlign', () => applyCellTextAlign('left'));
onClick('applyCellTextCenterAlign', () => applyCellTextAlign('center'));
onClick('applyCellTextRightAlign', () => applyCellTextAlign('right'));
//
onClick('applyBoldStyle', e => {
flexSheet.applyCellsStyle({ fontWeight: selectionFormatState.isBold ? 'none' : 'bold' });
selectionFormatState.isBold = !selectionFormatState.isBold;
//
if (selectionFormatState.isBold) {
wijmo.addClass(e.target, 'active');
}
else {
wijmo.removeClass(e.target, 'active');
}
});
//
function updateTextDecoration() {
const decorations = [];
if (selectionFormatState.isUnderline) {
decorations.push('underline');
}
if (selectionFormatState.isStrikethrough) {
decorations.push('line-through');
}
flexSheet.applyCellsStyle({
textDecoration: decorations.length ? decorations.join(' ') : 'none'
});
}
onClick('applyUnderlineStyle', e => {
selectionFormatState.isUnderline = !selectionFormatState.isUnderline;
if (selectionFormatState.isUnderline) {
wijmo.addClass(e.target, 'active');
}
else {
wijmo.removeClass(e.target, 'active');
}
updateTextDecoration();
});
onClick('applyStrikethroughStyle', e => {
selectionFormatState.isStrikethrough = !selectionFormatState.isStrikethrough;
if (selectionFormatState.isStrikethrough) {
wijmo.addClass(e.target, 'active');
}
else {
wijmo.removeClass(e.target, 'active');
}
updateTextDecoration();
});
onClick('applyItalicStyle', e => {
flexSheet.applyCellsStyle({ fontStyle: selectionFormatState.isItalic ? 'none' : 'italic' });
selectionFormatState.isItalic = !selectionFormatState.isItalic;
if (selectionFormatState.isItalic) {
wijmo.addClass(e.target, 'active');
}
else {
wijmo.removeClass(e.target, 'active');
}
});
//
onClick('foreColor', (e) => showColorPicker(e, false));
onClick('fillColor', (e) => showColorPicker(e, true));
//
// apply the text alignment for the selected cells
function applyCellTextAlign(textAlign) {
flexSheet.applyCellsStyle({ textAlign: textAlign });
selectionFormatState.textAlign = textAlign;
updateTextAlignState(textAlign);
}
//
// show the color picker control.
function showColorPicker(e, isFillColor) {
let offset = cumulativeOffset(e.target), he = inputColor.hostElement;
//
he.style.display = 'inline';
he.style.left = offset.left + 'px';
he.style.top = (offset.top - he.clientHeight - 5) + 'px';
he.focus();
//
applyFillColor = isFillColor;
}
//
// Update the selection object of the scope.
function updateSelection(sel) {
let rCnt = flexSheet.rows.length, cCnt = flexSheet.columns.length;
//
updatingSelection = true;
//
if (sel.row > -1 && sel.col > -1 && rCnt > 0 && cCnt > 0 && sel.col < cCnt && sel.col2 < cCnt && sel.row < rCnt && sel.row2 < rCnt) {
let cellContent = flexSheet.getCellData(sel.row, sel.col, false), cellStyle = flexSheet.selectedSheet.getCellStyle(sel.row, sel.col), cellFormat = '';
//
if (cellStyle) {
cboFontName.selectedIndex = checkFontfamily(cellStyle.fontFamily);
cboFontSize.selectedIndex = checkFontSize(cellStyle.fontSize);
cellFormat = cellStyle.format;
}
else {
cboFontName.selectedIndex = 0;
cboFontSize.selectedIndex = 5;
}
//
if (!cellFormat) {
if (wijmo.isInt(cellContent)) {
cellFormat = '0';
}
else if (wijmo.isNumber(cellContent)) {
cellFormat = 'n2';
}
else if (wijmo.isDate(cellContent)) {
cellFormat = 'd';
}
}
//
formatMenu.selectedValue = cellFormat;
//
selectionFormatState = flexSheet.getSelectionFormatState();
updateStyleButtonState();
}
//
updatingSelection = false;
}
//
function updateStyleButtonState() {
let boldBtn = document.querySelector('#applyBoldStyle'), underlineBtn = document.querySelector('#applyUnderlineStyle'), strikethroughBtn = document.querySelector('#applyStrikethroughStyle'), italicBtn = document.querySelector('#applyItalicStyle');
//
if (selectionFormatState.isBold) {
wijmo.addClass(boldBtn, 'active');
}
else {
wijmo.removeClass(boldBtn, 'active');
}
//
if (selectionFormatState.isUnderline) {
wijmo.addClass(underlineBtn, 'active');
}
else {
wijmo.removeClass(underlineBtn, 'active');
}
//
if (selectionFormatState.isStrikethrough) {
wijmo.addClass(strikethroughBtn, 'active');
}
else {
wijmo.removeClass(strikethroughBtn, 'active');
}
//
if (selectionFormatState.isItalic) {
wijmo.addClass(italicBtn, 'active');
}
else {
wijmo.removeClass(italicBtn, 'active');
}
//
updateTextAlignState(selectionFormatState.textAlign);
}
//
function updateTextAlignState(textAlign) {
let leftBtn = document.querySelector('#applyCellTextLeftAlign'), centerBtn = document.querySelector('#applyCellTextCenterAlign'), rightBtn = document.querySelector('#applyCellTextRightAlign');
//
wijmo.removeClass(leftBtn, 'active');
wijmo.removeClass(centerBtn, 'active');
wijmo.removeClass(rightBtn, 'active');
//
switch (textAlign) {
case 'left':
wijmo.addClass(leftBtn, 'active');
break;
case 'center':
wijmo.addClass(centerBtn, 'active');
break;
case 'right':
wijmo.addClass(rightBtn, 'active');
break;
}
}
//
// check font family for the font name combobox of the ribbon.
function checkFontfamily(value) {
if (!value) {
return 0;
}
//
for (let fontIndex = 0; fontIndex < fonts.length; fontIndex++) {
let font = fonts[fontIndex];
if (font.name === value || font.value === value) {
return fontIndex;
}
}
//
return 0;
}
//
// check font size for the font size combobox of the ribbon.
function checkFontSize(value) {
if (value == null) {
return 5;
}
//
for (let index = 0; index < fontSizeList.length; index++) {
let size = fontSizeList[index];
if (size.value === value || size.name === value) {
return index;
}
}
//
return 5;
}
//
// Get the absolute position of the dom element.
function cumulativeOffset(element) {
let top = 0, left = 0, scrollTop = 0, scrollLeft = 0;
//
do {
top += element.offsetTop || 0;
left += element.offsetLeft || 0;
scrollTop += element.scrollTop || 0;
scrollLeft += element.scrollLeft || 0;
element = element.offsetParent;
} while (element && !(element instanceof HTMLBodyElement));
//
scrollTop += document.body.scrollTop || document.documentElement.scrollTop;
scrollLeft += document.body.scrollLeft || document.documentElement.scrollLeft;
//
return {
top: top - scrollTop,
left: left - scrollLeft
};
}
//
function onClick(id, fn) {
document.querySelector('#' + id).addEventListener('click', fn);
}
//
function updateMenuHeader(menu, header) {
menu.header = header + ': <b>' + menu.text + '</b>';
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Formatting Cells</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="formatSheet"></div>
<div id="inputColor" style="display:none;position:fixed;z-index:100"></div>
<div class="p-4 border rounded bg-body-tertiary">
<div>
<select id="formatMenu">
<option value="0">Decimal Format</option>
<option value="n2">Number Format</option>
<option value="p2">Percentage Format</option>
<option value="c2">Currency Format</option>
<option></option>
<option value="d">Short Date</option>
<option value="D">Long Date</option>
<option value="f">Full Date/TIme (short time)</option>
<option value="F">Full Date/TIme (long time)</option>
</select>
</div>
<div>
Font:
<div id="fonts" style="width: 120px"></div>
<div id="fontSize" style="width: 80px"></div>
<div class="btn-group">
<button id="applyBoldStyle" type="button" class="btn btn-outline-secondary">Bold</button>
<button id="applyItalicStyle" type="button" class="btn btn-outline-secondary">Italic</button>
<button id="applyUnderlineStyle" type="button" class="btn btn-outline-secondary">Underline</button>
<button id="applyStrikethroughStyle" type="button" class="btn btn-outline-secondary">Strikethrough</button>
</div>
</div>
<div>
Color:
<div class="btn-group">
<button id="foreColor" type="button" class="btn btn-outline-secondary">Fore Color</button>
<button id="fillColor" type="button" class="btn btn-outline-secondary">Fill Color</button>
</div>
Alignment:
<div class="btn-group">
<button id="applyCellTextLeftAlign" type="button" class="btn btn-outline-secondary">Left</button>
<button id="applyCellTextCenterAlign" type="button" class="btn btn-outline-secondary">Center</button>
<button id="applyCellTextRightAlign" type="button" class="btn btn-outline-secondary">Right</button>
</div>
</div>
</div>
</div>
</body>
</html>
.wj-flexsheet {
height: 400px;
margin: 6px 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridSheetModule } from '@mescius/wijmo.angular2.grid.sheet';
import * as wijmo from '@mescius/wijmo';
import * as input from '@mescius/wijmo.input';
import * as grid from '@mescius/wijmo.grid';
import * as sheet from '@mescius/wijmo.grid.sheet';
@Component({
standalone: true,
imports: [WjGridSheetModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
@ViewChild('flex', { static: true }) flex: sheet.FlexSheet;
@ViewChild('cboFontName', { static: true }) cboFontName: input.ComboBox;
@ViewChild('cboFontSize', { static: true }) cboFontSize: input.ComboBox;
@ViewChild('cboTableStyles', { static: true }) cboTableStyles: input.ComboBox;
@ViewChild('colorPicker', { static: true }) colorPicker: input.ColorPicker;
fonts = [
{ name: 'Arial', value: 'Arial, Helvetica, sans-serif' },
{ name: 'Arial Black', value: '"Arial Black", Gadget, sans-serif' },
{ name: 'Comic Sans MS', value: '"Comic Sans MS", cursive, sans-serif' },
{ name: 'Courier New', value: '"Courier New", Courier, monospace' },
{ name: 'Georgia', value: 'Georgia, serif' },
{ name: 'Impact', value: 'Impact, Charcoal, sans-serif' },
{ name: 'Lucida Console', value: '"Lucida Console", Monaco, monospace' },
{ name: 'Lucida Sans Unicode', value: '"Lucida Sans Unicode", "Lucida Grande", sans-serif' },
{ name: 'Palatino Linotype', value: '"Palatino Linotype", "Book Antiqua", Palatino, serif' },
{ name: 'Tahoma', value: 'Tahoma, Geneva, sans-serif' },
{ name: 'Segoe UI', value: '"Segoe UI", "Roboto", sans-serif' },
{ name: 'Times New Roman', value: '"Times New Roman", Times, serif' },
{ name: 'Trebuchet MS', value: '"Trebuchet MS", Helvetica, sans-serif' },
{ name: 'Verdana', value: 'Verdana, Geneva, sans-serif' },
];
fontSizeList = [
{ name: '8', value: '8px' },
{ name: '9', value: '9px' },
{ name: '10', value: '10px' },
{ name: '11', value: '11px' },
{ name: '12', value: '12px' },
{ name: '14', value: '14px' },
{ name: '16', value: '16px' },
{ name: '18', value: '18px' },
{ name: '20', value: '20px' },
{ name: '22', value: '22px' },
{ name: '24', value: '24px' },
];
selectionFormatState: sheet.IFormatState = {};
private _updatingSelection = false;
private _applyFillColor = false;
private _format = '';
// Gets or sets _format for the formatSheet.
get format(): string {
return this._format;
}
set format(value: string) {
if (this._format !== value) {
this._format = value;
if (!this._updatingSelection) {
this.flex.applyCellsStyle({ format: this._format });
}
}
}
initializeFlexSheet(flex: sheet.FlexSheet) {
flex.deferUpdate(() => {
for (let sheetIdx = 0; sheetIdx < flex.sheets.length; sheetIdx++) {
flex.selectedSheetIndex = sheetIdx;
let sheetName = flex.selectedSheet.name;
for (let colIdx = 0; colIdx < flex.columns.length; colIdx++) {
for (let rowIdx = 0; rowIdx < flex.rows.length; rowIdx++) {
if (sheetName === 'Number') {
flex.setCellData(rowIdx, colIdx, colIdx + rowIdx);
} else {
let date = new Date(2015, colIdx, rowIdx + 1);
flex.setCellData(rowIdx, colIdx, date);
}
}
}
}
flex.selectedSheetIndex = 0;
setTimeout(() => this._updateSelection(flex, flex.selection), 100);
});
flex.selectionChanged.addHandler((sender: sheet.FlexSheet, args: grid.CellRangeEventArgs) => {
this._updateSelection(flex, args.range);
});
}
fontChanged(sender: input.ComboBox) {
if (sender.selectedItem && !this._updatingSelection) {
this.flex.applyCellsStyle({ fontFamily: sender.selectedItem.value });
}
}
fontSizeChanged(sender: input.ComboBox) {
if (sender.selectedItem && !this._updatingSelection) {
this.flex.applyCellsStyle({ fontSize: sender.selectedItem.value });
}
}
colorPickerInit(colorPicker: input.ColorPicker) {
// if the browser is Firefox, we should bind the blur event. (TFS #124387)
// if the browser is IE, we should bind the focusout event. (TFS #124500)
let blurEvt = /firefox/i.test(window.navigator.userAgent) ? 'blur' : 'focusout';
// Hide the color picker control when it lost the focus.
colorPicker.hostElement.addEventListener(blurEvt, () => {
setTimeout(() => {
if (!colorPicker.containsFocus()) {
this._applyFillColor = false;
colorPicker.hostElement.style.display = 'none';
}
}, 0);
});
// Initialize the value changed event handler for the color picker control.
colorPicker.valueChanged.addHandler(() => {
if (this._applyFillColor) {
this.flex.applyCellsStyle({ backgroundColor: colorPicker.value });
} else {
this.flex.applyCellsStyle({ color: colorPicker.value });
}
});
}
// apply the text alignment for the selected cells
applyCellTextAlign(textAlign: string) {
this.flex.applyCellsStyle({ textAlign: textAlign });
this.selectionFormatState.textAlign = textAlign;
}
// apply the bold font weight for the selected cells
applyBoldStyle() {
this.flex.applyCellsStyle({ fontWeight: this.selectionFormatState.isBold ? 'none' : 'bold' });
this.selectionFormatState.isBold = !this.selectionFormatState.isBold;
}
// apply the underline text decoration for the selected cells
applyUnderlineStyle() {
this.flex.applyCellsStyle({ textDecoration: this.selectionFormatState.isUnderline ? 'none' : 'underline' });
this.selectionFormatState.isUnderline = !this.selectionFormatState.isUnderline;
}
// apply the italic font style for the selected cells
applyItalicStyle() {
this.flex.applyCellsStyle({ fontStyle: this.selectionFormatState.isItalic ? 'none' : 'italic' });
this.selectionFormatState.isItalic = !this.selectionFormatState.isItalic;
}
// show the color picker control
showColorPicker(e: MouseEvent, isFillColor: boolean) {
let offset = this._cumulativeOffset(<HTMLElement>e.target),
he = this.colorPicker.hostElement;
he.style.display = 'inline';
he.style.left = offset.left + 'px';
he.style.top = offset.top - he.clientHeight - 5 + 'px';
he.focus();
this._applyFillColor = isFillColor;
}
// Update the selection object of the scope.
private _updateSelection(fs: sheet.FlexSheet, sel: grid.CellRange) {
let rCnt = fs.rows.length,
cCnt = fs.columns.length;
this._updatingSelection = true;
if (
sel.row > -1 &&
sel.col > -1 &&
rCnt > 0 &&
cCnt > 0 &&
sel.col < cCnt &&
sel.col2 < cCnt &&
sel.row < rCnt &&
sel.row2 < rCnt
) {
let cellContent = fs.getCellData(sel.row, sel.col, false),
cellStyle = fs.selectedSheet.getCellStyle(sel.row, sel.col),
cellFormat: string;
if (cellStyle) {
this.cboFontName.selectedIndex = this._checkFontfamily(cellStyle.fontFamily);
this.cboFontSize.selectedIndex = this._checkFontSize(cellStyle.fontSize);
cellFormat = cellStyle.format;
} else {
this.cboFontName.selectedIndex = 0;
this.cboFontSize.selectedIndex = 5;
}
if (!!cellFormat) {
this.format = cellFormat;
} else {
if (wijmo.isInt(cellContent)) {
this.format = '0';
} else if (wijmo.isNumber(cellContent)) {
this.format = 'n2';
} else if (wijmo.isDate(cellContent)) {
this.format = 'd';
}
}
this.selectionFormatState = fs.getSelectionFormatState();
}
this._updatingSelection = false;
}
// check font family for the font name combobox of the ribbon.
private _checkFontfamily(value: string) {
let fonts = this.fonts;
if (!value) {
return 0;
}
for (let fontIndex = 0; fontIndex < fonts.length; fontIndex++) {
let font = fonts[fontIndex];
if (font.name === value || font.value === value) {
return fontIndex;
}
}
return 0;
}
// check font size for the font size combobox of the ribbon.
private _checkFontSize(value: string) {
let sizeList = this.fontSizeList;
if (value == null) {
return 5;
}
for (let index = 0; index < sizeList.length; index++) {
let size = sizeList[index];
if (size.value === value || size.name === value) {
return index;
}
}
return 5;
}
// Get the absolute position of the dom element.
private _cumulativeOffset(element: HTMLElement) {
let top = 0,
left = 0,
scrollTop = 0,
scrollLeft = 0;
do {
top += element.offsetTop || 0;
left += element.offsetLeft || 0;
scrollTop += element.scrollTop || 0;
scrollLeft += element.scrollLeft || 0;
element = <HTMLElement>element.offsetParent;
} while (element && !(element instanceof HTMLBodyElement));
scrollTop += document.body.scrollTop || document.documentElement.scrollTop;
scrollLeft += document.body.scrollLeft || document.documentElement.scrollLeft;
return {
top: top - scrollTop,
left: left - scrollLeft,
};
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Formatting Cells</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<!-- the flexsheet -->
<wj-flex-sheet #flex
(initialized)="initializeFlexSheet(flex)">
<wj-sheet name="Number" [rowCount]="20" [columnCount]="8"></wj-sheet>
<wj-sheet name="Date" [rowCount]="20" [columnCount]="8"></wj-sheet>
</wj-flex-sheet>
<wj-color-picker #colorPicker style="display:none;position:fixed;z-index:100" (initialized)="colorPickerInit(colorPicker)"></wj-color-picker>
<div class="well well-lg">
<div>
<wj-menu header="Format" [(value)]="format">
<wj-menu-item value="0">Decimal Format</wj-menu-item>
<wj-menu-item value="n2">Number Format</wj-menu-item>
<wj-menu-item value="p">Percentage Format</wj-menu-item>
<wj-menu-item value="c2">Currency Format</wj-menu-item>
<wj-menu-separator></wj-menu-separator>
<wj-menu-item value="d">Short Date</wj-menu-item>
<wj-menu-item value="D">Long Date</wj-menu-item>
<wj-menu-item value="f">Full Date/TIme (short time)</wj-menu-item>
<wj-menu-item value="F">Full Date/TIme (long time)</wj-menu-item>
</wj-menu>
</div>
<div>
Font:
<wj-combo-box #cboFontName
style="width:120px"
[itemsSource]="fonts"
[selectedIndex]="0"
[displayMemberPath]="'name'"
[selectedValuePath]="'value'"
[isEditable]="false"
(selectedIndexChanged)="fontChanged(cboFontName)">
</wj-combo-box>
<wj-combo-box #cboFontSize
style="width:80px"
[itemsSource]="fontSizeList"
[selectedIndex]="5"
[displayMemberPath]="'name'"
[selectedValuePath]="'value'"
[isEditable]="false"
(selectedIndexChanged)="fontSizeChanged(cboFontSize)">
</wj-combo-box>
<div class="btn-group">
<button type="button" class="btn btn-default {{selectionFormatState.isBold ? 'active' : ''}}" (click)="applyBoldStyle()">Bold</button>
<button type="button" class="btn btn-default {{selectionFormatState.isItalic ? 'active' : ''}}" (click)="applyItalicStyle()">Italic</button>
<button type="button" class="btn btn-default {{selectionFormatState.isUnderline ? 'active' : ''}}" (click)="applyUnderlineStyle()">Underline</button>
</div>
</div>
<div>
Color:
<div class="btn-group">
<button type="button" class="btn btn-default" (click)="showColorPicker($event, false)">Fore Color</button>
<button type="button" class="btn btn-default" (click)="showColorPicker($event, true)">Fill Color</button>
</div>
Alignment:
<div class="btn-group">
<button type="button" class="btn btn-default {{selectionFormatState.textAlign === 'left' ? 'active' : ''}}" (click)="applyCellTextAlign('left')">Left</button>
<button type="button" class="btn btn-default {{selectionFormatState.textAlign === 'center' ? 'active' : ''}}" (click)="applyCellTextAlign('center')">Center</button>
<button type="button" class="btn btn-default {{selectionFormatState.textAlign === 'right' ? 'active' : ''}}" (click)="applyCellTextAlign('right')">Right</button>
</div>
</div>
</div>
</div>
.wj-flexsheet {
height: 400px;
margin: 6px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

<template>
<div class="container-fluid">
<!-- the flexsheet -->
<wj-flex-sheet :initialized="initializeFlexSheet">
<wj-sheet name="Number" :rowCount="20" :columnCount="8"></wj-sheet>
<wj-sheet name="Date" :rowCount="20" :columnCount="8"></wj-sheet>
</wj-flex-sheet>
<wj-color-picker style="display:none;position:fixed;z-index:100" :initialized="colorPickerInit">
</wj-color-picker>
<div class="well well-lg">
<wj-menu :header="'Format'" :value="format" :itemClicked="formatChanged">
<wj-menu-item :value="'0'">Decimal Format</wj-menu-item>
<wj-menu-item :value="'n2'">Number Format</wj-menu-item>
<wj-menu-item :value="'p'">Percentage Format</wj-menu-item>
<wj-menu-item :value="'c2'">Currency Format</wj-menu-item>
<wj-menu-separator></wj-menu-separator>
<wj-menu-item :value="'d'">Short Date</wj-menu-item>
<wj-menu-item :value="'D'">Long Date</wj-menu-item>
<wj-menu-item :value="'f'">Full Date/TIme (short time)</wj-menu-item>
<wj-menu-item :value="'F'">Full Date/TIme (long time)</wj-menu-item>
</wj-menu>
<div>Font:
<wj-combo-box style="width:120px" :itemsSource="fonts" :selectedIndex="fontIdx" displayMemberPath="name"
selectedValuePath="value" :isEditable="false" :selectedIndexChanged="fontChanged">
</wj-combo-box>
<wj-combo-box style="width:80px" :itemsSource="fontSizeList" :selectedIndex="fontSizeIdx"
displayMemberPath="name" selectedValuePath="value" :isEditable="false"
:selectedIndexChanged="fontSizeChanged">
</wj-combo-box>
<div class="btn-group">
<button type="button" v-bind:class="['btn btn-default', { active: isBold }]"
@click="applyBoldStyle()">
Bold</button>
<button type="button" v-bind:class="['btn btn-default', { active: isItalic }]"
@click="applyItalicStyle()">
Italic</button>
<button type="button" v-bind:class="['btn btn-default', { active: isUnderline }]"
@click="applyUnderlineStyle()">
Underline</button>
</div>
</div>
<div>Color:
<div class="btn-group">
<button type="button" class="btn btn-default" @click="showColorPicker($event, false)">
Fore Color</button>
<button type="button" class="btn btn-default" @click="showColorPicker($event, true)">
Fill Color</button>
</div>Alignment:
<div class="btn-group">
<button type="button" v-bind:class="['btn btn-default', { active: textAlign == 'left' }]"
@click="applyCellTextAlign('left')">
Left</button>
<button type="button" v-bind:class="['btn btn-default', { active: textAlign == 'center' }]"
@click="applyCellTextAlign('center')">
Center</button>
<button type="button" v-bind:class="['btn btn-default', { active: textAlign == 'right' }]"
@click="applyCellTextAlign('right')">
Right</button>
</div>
</div>
</div>
</div>
</template>
<script setup>
import { ref } from "vue";
const fonts = ref([
{ name: "Arial", value: "Arial, Helvetica, sans-serif" },
{ name: "Arial Black", value: '"Arial Black", Gadget, sans-serif' },
{ name: "Comic Sans MS", value: '"Comic Sans MS", cursive, sans-serif' },
{ name: "Courier New", value: '"Courier New", Courier, monospace' },
{ name: "Georgia", value: "Georgia, serif" },
{ name: "Impact", value: "Impact, Charcoal, sans-serif" },
{ name: "Lucida Console", value: '"Lucida Console", Monaco, monospace' },
{ name: "Lucida Sans Unicode", value: '"Lucida Sans Unicode", "Lucida Grande", sans-serif' },
{ name: "Palatino Linotype", value: '"Palatino Linotype", "Book Antiqua", Palatino, serif' },
{ name: "Tahoma", value: "Tahoma, Geneva, sans-serif" },
{ name: "Segoe UI", value: '"Segoe UI", "Roboto", sans-serif' },
{ name: "Times New Roman", value: '"Times New Roman", Times, serif' },
{ name: "Trebuchet MS", value: '"Trebuchet MS", Helvetica, sans-serif' },
{ name: "Verdana", value: "Verdana, Geneva, sans-serif" },
]);
const fontSizeList = ref([
{ name: "8", value: "8px" },
{ name: "9", value: "9px" },
{ name: "10", value: "10px" },
{ name: "11", value: "11px" },
{ name: "12", value: "12px" },
{ name: "14", value: "14px" },
{ name: "16", value: "16px" },
{ name: "18", value: "18px" },
{ name: "20", value: "20px" },
{ name: "22", value: "22px" },
{ name: "24", value: "24px" },
]);
const format = ref("0");
const fontIdx = ref(0);
const fontSizeIdx = ref(5);
const isBold = ref(false);
const isItalic = ref(false);
const isUnderline = ref(false);
const textAlign = ref("left");
const _updatingSelection = ref(false);
const _applyFillColor = ref(false);
const flex = ref({});
const colorPicker = ref({});
function initializeFlexSheet(flexref) {
flexref.deferUpdate(() => {
for (let sheetIdx = 0; sheetIdx < flexref.sheets.length; sheetIdx++) {
flexref.selectedSheetIndex = sheetIdx;
let sheetName = flexref.selectedSheet.name;
for (let colIdx = 0; colIdx < flexref.columns.length; colIdx++) {
for (let rowIdx = 0; rowIdx < flexref.rows.length; rowIdx++) {
if (sheetName === "Number") {
flexref.setCellData(rowIdx, colIdx, colIdx + rowIdx);
} else {
let date = new Date(2015, colIdx, rowIdx + 1);
flexref.setCellData(rowIdx, colIdx, date);
}
}
}
}
flexref.selectedSheetIndex = 0;
setTimeout(() => _updateSelection(flex.value, flexref.selection), 100);
});
flexref.selectionChanged.addHandler((sender, args) => {
_updateSelection(flex.value, args.range);
});
flex.value = flexref;
}
function fontChanged(sender) {
if (sender.selectedItem && !_updatingSelection.value) {
flex.value.applyCellsStyle({ fontFamily: sender.selectedItem.value });
}
}
function fontSizeChanged(sender) {
if (sender.selectedItem && !_updatingSelection.value) {
flex.value.applyCellsStyle({ fontSize: sender.selectedItem.value });
}
}
function colorPickerInit(colorPickerref) {
// if the browser is firefox, we should bind the blur event. (TFS #124387)
// if the browser is IE, we should bind the focusout event. (TFS #124500)
let blurEvt = /firefox/i.test(window.navigator.userAgent) ? "blur" : "focusout";
// Hide the color picker control when it lost the focus.
colorPickerref.hostElement.addEventListener(blurEvt, () => {
setTimeout(() => {
if (!colorPickerref.containsFocus()) {
_applyFillColor.value = false;
colorPickerref.hostElement.style.display = "none";
}
}, 0);
});
// Initialize the value changed event handler for the color picker control.
colorPickerref.valueChanged.addHandler(() => {
if (_applyFillColor.value) {
flex.value.applyCellsStyle({ backgroundColor: colorPickerref.value });
} else {
flex.value.applyCellsStyle({ color: colorPickerref.value });
}
});
colorPicker.value = colorPickerref;
}
function formatChanged(sender) {
if (sender.selectedIndex >= 0) {
flex.value.applyCellsStyle({ format: sender.selectedValue });
}
}
// apply the text alignment for the selected cells
function applyCellTextAlign(textAlignref) {
textAlign.value = textAlignref;
flex.value.applyCellsStyle({ textAlign: textAlign });
}
// apply the bold font weight for the selected cells
function applyBoldStyle() {
flex.value.applyCellsStyle({ fontWeight: isBold.value ? "none" : "bold" });
isBold.value = !isBold.value;
}
// apply the underline text decoration for the selected cells
function applyUnderlineStyle() {
flex.value.applyCellsStyle({ textDecoration: isUnderline.value ? "none" : "underline" });
isUnderline.value = !isUnderline.value;
}
// apply the italic font style for the selected cells
function applyItalicStyle() {
flex.value.applyCellsStyle({ fontStyle: isItalic.value ? "none" : "italic" });
isItalic.value = !isItalic.value;
}
// show the color picker control.
function showColorPicker(e, isFillColor) {
let offset = _cumulativeOffset(e.target),
he = colorPicker.value.hostElement;
he.style.display = "inline";
he.style.left = offset.left + "px";
he.style.top = offset.top - he.clientHeight - 5 + "px";
he.focus();
_applyFillColor.value = isFillColor;
}
// Update the selection object of the scope.
function _updateSelection(flexSheet, sel) {
let row = flexSheet.rows[sel.row],
rCnt = flexSheet.rows.length,
cCnt = flexSheet.columns.length,
fontIndex = 0,
fontSizeIndex = 5;
_updatingSelection.value = true;
if (sel.row > -1 && sel.col > -1 && rCnt > 0 && cCnt > 0 && sel.col < cCnt && sel.col2 < cCnt && sel.row < rCnt && sel.row2 < rCnt) {
let cellContent = flexSheet.getCellData(sel.row, sel.col, false),
cellStyle = flexSheet.selectedSheet.getCellStyle(sel.row, sel.col),
cellFormat = null;
if (cellStyle) {
fontIndex = _checkFontfamily(cellStyle.fontFamily);
fontSizeIndex = _checkFontSize(cellStyle.fontSize);
cellFormat = cellStyle.format;
}
let fmt;
if (!!cellFormat) {
fmt = cellFormat;
} else {
if (wijmo.isInt(cellContent)) {
fmt = "0";
} else if (wijmo.isNumber(cellContent)) {
fmt = "n2";
} else if (wijmo.isDate(cellContent)) {
fmt = "d";
}
}
fontIdx.value = fontIndex;
fontSizeIdx.value = fontSizeIndex;
format.value = fmt;
let state = flexSheet.getSelectionFormatState();
isBold.value = state.isBold;
isItalic.value = state.isItalic;
isUnderline.value = state.isUnderline;
textAlign.value = state.textAlign;
}
_updatingSelection.value = false;
}
// check font family for the font name combobox of the ribbon.
function _checkFontfamily(fontFamily) {
let fontList = fonts.value;
if (!fontFamily) {
return 0;
}
for (let fontIndex = 0; fontIndex < fontList.length; fontIndex++) {
let font = fontList[fontIndex];
if (font.name === fontFamily || font.value === fontFamily) {
return fontIndex;
}
}
return 0;
}
// check font size for the font size combobox of the ribbon.
function _checkFontSize(fontSize) {
let sizeList = fontSizeList.value;
if (fontSize == null) {
return 5;
}
for (let index = 0; index < sizeList.length; index++) {
let size = sizeList[index];
if (size.value === fontSize || size.name === fontSize) {
return index;
}
}
return 5;
}
// Get the absolute position of the dom element.
function _cumulativeOffset(element) {
let top = 0,
left = 0,
scrollTop = 0,
scrollLeft = 0;
do {
top += element.offsetTop || 0;
left += element.offsetLeft || 0;
scrollTop += element.scrollTop || 0;
scrollLeft += element.scrollLeft || 0;
element = element.offsetParent;
} while (element && !(element instanceof HTMLBodyElement));
scrollTop += document.body.scrollTop || document.documentElement.scrollTop;
scrollLeft += document.body.scrollLeft || document.documentElement.scrollLeft;
return {
top: top - scrollTop,
left: left - scrollLeft,
};
}
</script>
<style>
.container-fluid .wj-flexsheet {
height: 400px;
margin: 6px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Formatting Cells</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wijmo from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.react.input';
import * as wjGridSheet from '@mescius/wijmo.react.grid.sheet';
import './app.css';
const fonts = [
{ name: 'Arial', value: 'Arial, Helvetica, sans-serif' },
{ name: 'Arial Black', value: '"Arial Black", Gadget, sans-serif' },
{ name: 'Comic Sans MS', value: '"Comic Sans MS", cursive, sans-serif' },
{ name: 'Courier New', value: '"Courier New", Courier, monospace' },
{ name: 'Georgia', value: 'Georgia, serif' },
{ name: 'Impact', value: 'Impact, Charcoal, sans-serif' },
{ name: 'Lucida Console', value: '"Lucida Console", Monaco, monospace' },
{ name: 'Lucida Sans Unicode', value: '"Lucida Sans Unicode", "Lucida Grande", sans-serif' },
{ name: 'Palatino Linotype', value: '"Palatino Linotype", "Book Antiqua", Palatino, serif' },
{ name: 'Tahoma', value: 'Tahoma, Geneva, sans-serif' },
{ name: 'Segoe UI', value: '"Segoe UI", "Roboto", sans-serif' },
{ name: 'Times New Roman', value: '"Times New Roman", Times, serif' },
{ name: 'Trebuchet MS', value: '"Trebuchet MS", Helvetica, sans-serif' },
{ name: 'Verdana', value: 'Verdana, Geneva, sans-serif' }
];
const fontSizeList = [
{ name: '8', value: '8px' },
{ name: '9', value: '9px' },
{ name: '10', value: '10px' },
{ name: '11', value: '11px' },
{ name: '12', value: '12px' },
{ name: '14', value: '14px' },
{ name: '16', value: '16px' },
{ name: '18', value: '18px' },
{ name: '20', value: '20px' },
{ name: '22', value: '22px' },
{ name: '24', value: '24px' }
];
function App() {
const [format, setFormat] = useState('0');
const [fontIdx, setFontIdx] = useState(0);
const [fontSizeIdx, setFontSizeIdx] = useState(5);
const [isBold, setIsBold] = useState(false);
const [isItalic, setIsItalic] = useState(false);
const [isUnderline, setIsUnderline] = useState(false);
const [textAlign, setTextAlign] = useState('left');
const applyFillColorRef = useRef(false);
const updatingSelectionRef = useRef(false);
const flexRef = useRef(null);
const colorPickerRef = useRef(null);
const initializeFlexSheet = useEvent((sender) => {
flexRef.current = sender;
sender.deferUpdate(() => {
for (let sheetIdx = 0; sheetIdx < sender.sheets.length; sheetIdx++) {
sender.selectedSheetIndex = sheetIdx;
let sheetName = sender.selectedSheet.name;
//
for (let colIdx = 0; colIdx < sender.columns.length; colIdx++) {
for (let rowIdx = 0; rowIdx < sender.rows.length; rowIdx++) {
if (sheetName === 'Number') {
sender.setCellData(rowIdx, colIdx, colIdx + rowIdx);
}
else {
let date = new Date(2015, colIdx, rowIdx + 1);
sender.setCellData(rowIdx, colIdx, date);
}
}
}
}
//
sender.selectedSheetIndex = 0;
setTimeout(() => updateSelection(sender, sender.selection), 100);
});
//
sender.selectionChanged.addHandler((sender, args) => {
updateSelection(sender, args.range);
});
});
const fontChanged = useEvent((sender) => {
var _a;
if (sender.selectedItem && !updatingSelectionRef.current) {
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ fontFamily: sender.selectedItem.value });
}
});
const fontSizeChanged = useEvent((sender) => {
var _a;
if (sender.selectedItem && !updatingSelectionRef.current) {
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ fontSize: sender.selectedItem.value });
}
});
const colorPickerInit = useEvent((sender) => {
// if the browser is firefox, we should bind the blur event. (TFS #124387)
// if the browser is IE, we should bind the focusout event. (TFS #124500)
let blurEvt = /firefox/i.test(window.navigator.userAgent) ? 'blur' : 'focusout';
// Hide the color picker control when it lost the focus.
sender.hostElement.addEventListener(blurEvt, () => {
setTimeout(() => {
if (!sender.containsFocus()) {
updatingSelectionRef.current = false;
sender.hostElement.style.display = 'none';
}
}, 0);
});
//
// Initialize the value changed event handler for the color picker control.
sender.valueChanged.addHandler(() => {
var _a, _b;
if (applyFillColorRef.current) {
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ backgroundColor: sender.value });
}
else {
(_b = flexRef.current) === null || _b === void 0 ? void 0 : _b.applyCellsStyle({ color: sender.value });
}
});
//
colorPickerRef.current = sender;
});
const formatChanged = useEvent((sender) => {
var _a;
if (sender.selectedValue) {
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ format: sender.selectedValue });
setFormat(sender.selectedValue);
}
});
// apply the text alignment for the selected cells
const applyCellTextAlign = (value) => {
var _a;
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ textAlign: value });
setTextAlign(value);
};
// apply the bold font weight for the selected cells
const applyBoldStyle = () => {
var _a;
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ fontWeight: isBold ? 'none' : 'bold' });
setIsBold(!isBold);
};
// apply the underline text decoration for the selected cells
const applyUnderlineStyle = () => {
var _a;
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ textDecoration: isUnderline ? 'none' : 'underline' });
setIsUnderline(!isUnderline);
};
// apply the italic font style for the selected cells
const applyItalicStyle = () => {
var _a;
(_a = flexRef.current) === null || _a === void 0 ? void 0 : _a.applyCellsStyle({ fontStyle: isItalic ? 'none' : 'italic' });
setIsItalic(!isItalic);
};
// show the color picker control.
const showColorPicker = (e, isFillColor) => {
var _a;
let offset = cumulativeOffset(e.target);
//
let he = (_a = colorPickerRef.current) === null || _a === void 0 ? void 0 : _a.hostElement;
if (he) {
he.style.display = 'inline';
he.style.left = offset.left + 'px';
he.style.top = offset.top - he.clientHeight - 5 + 'px';
he.focus();
}
//
applyFillColorRef.current = isFillColor;
};
// Update the selection object of the scope.
const updateSelection = (fs, sel) => {
let rCnt = fs.rows.length, cCnt = fs.columns.length, fontIdx = 0, fontSizeIdx = 5;
//
updatingSelectionRef.current = true;
//
if (sel.row > -1 && sel.col > -1 && rCnt > 0 && cCnt > 0 && sel.col < cCnt && sel.col2 < cCnt && sel.row < rCnt && sel.row2 < rCnt) {
let cellContent = fs.getCellData(sel.row, sel.col, false), cellStyle = fs.selectedSheet.getCellStyle(sel.row, sel.col), cellFormat = '';
if (cellStyle) {
if (cellStyle.fontFamily) {
fontIdx = checkFontfamily(cellStyle.fontFamily);
}
if (cellStyle.fontSize) {
fontSizeIdx = checkFontSize(cellStyle.fontSize);
}
if (cellStyle.format) {
cellFormat = cellStyle.format;
}
}
let format = '';
if (!!cellFormat) {
format = cellFormat;
}
else {
if (wijmo.isInt(cellContent)) {
format = '0';
}
else if (wijmo.isNumber(cellContent)) {
format = 'n2';
}
else if (wijmo.isDate(cellContent)) {
format = 'd';
}
}
//
let state = fs.getSelectionFormatState();
setFormat(format);
setFontIdx(fontIdx);
setFontSizeIdx(fontSizeIdx);
}
//
updatingSelectionRef.current = false;
};
// check font family for the font name combobox of the ribbon.
const checkFontfamily = (value) => {
if (!value) {
return 0;
}
for (let fontIndex = 0; fontIndex < fonts.length; fontIndex++) {
let font = fonts[fontIndex];
if (font.name === value || font.value === value) {
return fontIndex;
}
}
//
return 0;
};
// check font size for the font size combobox of the ribbon.
const checkFontSize = (value) => {
let sizeList = fontSizeList;
//
if (value == null) {
return 5;
}
//
for (let index = 0; index < sizeList.length; index++) {
let size = sizeList[index];
if (size.value === value || size.name === value) {
return index;
}
}
//
return 5;
};
// Get the absolute position of the dom element.
const cumulativeOffset = (element) => {
let top = 0, left = 0, scrollTop = 0, scrollLeft = 0;
//
do {
top += element.offsetTop || 0;
left += element.offsetLeft || 0;
scrollTop += element.scrollTop || 0;
scrollLeft += element.scrollLeft || 0;
element = element.offsetParent;
} while (element && !(element instanceof HTMLBodyElement));
//
scrollTop += document.body.scrollTop || document.documentElement.scrollTop;
scrollLeft += document.body.scrollLeft || document.documentElement.scrollLeft;
//
return {
top: top - scrollTop,
left: left - scrollLeft
};
};
return (<div className="container-fluid">
<wjGridSheet.FlexSheet initialized={initializeFlexSheet}>
<wjGridSheet.Sheet name="Number" rowCount={20} columnCount={8}/>
<wjGridSheet.Sheet name="Date" rowCount={20} columnCount={8}/>
</wjGridSheet.FlexSheet>
<wjInput.ColorPicker style={{ display: "none", position: "fixed", zIndex: 100 }} initialized={colorPickerInit}>
</wjInput.ColorPicker>
<div className="well well-lg">
<wjInput.Menu header='Format' value={format} itemClicked={formatChanged}>
<wjInput.MenuItem value="0">Decimal Format</wjInput.MenuItem>
<wjInput.MenuItem value="n2">Number Format</wjInput.MenuItem>
<wjInput.MenuItem value="p">Percentage Format</wjInput.MenuItem>
<wjInput.MenuItem value="c2">Currency Format</wjInput.MenuItem>
<wjInput.MenuSeparator></wjInput.MenuSeparator>
<wjInput.MenuItem value="d">Short Date</wjInput.MenuItem>
<wjInput.MenuItem value="D">Long Date</wjInput.MenuItem>
<wjInput.MenuItem value="f">Full Date/TIme (short time)</wjInput.MenuItem>
<wjInput.MenuItem value="F">Full Date/TIme (long time)</wjInput.MenuItem>
</wjInput.Menu>
<div>Font:
<wjInput.ComboBox style={{ width: "120px" }} itemsSource={fonts} selectedIndex={fontIdx} displayMemberPath="name" selectedValuePath="value" isEditable={false} selectedIndexChanged={fontChanged}>
</wjInput.ComboBox>
<wjInput.ComboBox style={{ width: "80px" }} itemsSource={fontSizeList} selectedIndex={fontSizeIdx} displayMemberPath="name" selectedValuePath="value" isEditable={false} selectedIndexChanged={fontSizeChanged}>
</wjInput.ComboBox>
<div className="btn-group">
<button type="button" className={`btn btn-default ${isBold ? 'active' : ''}`} onClick={applyBoldStyle}>
Bold</button>
<button type="button" className={`btn btn-default ${isItalic ? 'active' : ''}`} onClick={applyItalicStyle}>
Italic</button>
<button type="button" className={`btn btn-default ${isUnderline ? 'active' : ''}`} onClick={applyUnderlineStyle}>
Underline</button>
</div>
</div>
<div>Color:
<div className="btn-group">
<button type="button" className="btn btn-default" onClick={(e) => showColorPicker(e, false)}>
Fore Color</button>
<button type="button" className="btn btn-default" onClick={(e) => showColorPicker(e, true)}>
Fill Color</button>
</div>Alignment:
<div className="btn-group">
<button type="button" className={`btn btn-default ${textAlign == 'left' ? 'active' : ''}`} onClick={() => applyCellTextAlign("left")}>
Left</button>
<button type="button" className={`btn btn-default ${textAlign == 'center' ? 'active' : ''}`} onClick={() => applyCellTextAlign("center")}>
Center</button>
<button type="button" className={`btn btn-default ${textAlign == 'right' ? 'active' : ''}`} onClick={() => applyCellTextAlign("right")}>
Right</button>
</div>
</div>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexSheet Formatting Cells</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.container-fluid .wj-flexsheet {
height: 400px;
margin: 6px 0;
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);